Index: /branches/GeneralizedQAP/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/Service References/QAPServiceReference/Reference.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/Service References/QAPServiceReference/Reference.cs	(revision 6732)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/Service References/QAPServiceReference/Reference.cs	(revision 6733)
@@ -24,8 +24,14 @@
         
         [System.Runtime.Serialization.OptionalFieldAttribute()]
+        private double BestKnownQualityField;
+        
+        [System.Runtime.Serialization.OptionalFieldAttribute()]
         private string DescriptionField;
         
         [System.Runtime.Serialization.OptionalFieldAttribute()]
         private double[][] DistancesField;
+        
+        [System.Runtime.Serialization.OptionalFieldAttribute()]
+        private bool HasBestKnownQualityField;
         
         [System.Runtime.Serialization.OptionalFieldAttribute()]
@@ -45,4 +51,17 @@
             set {
                 this.extensionDataField = value;
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public double BestKnownQuality {
+            get {
+                return this.BestKnownQualityField;
+            }
+            set {
+                if ((this.BestKnownQualityField.Equals(value) != true)) {
+                    this.BestKnownQualityField = value;
+                    this.RaisePropertyChanged("BestKnownQuality");
+                }
             }
         }
@@ -70,4 +89,17 @@
                     this.DistancesField = value;
                     this.RaisePropertyChanged("Distances");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public bool HasBestKnownQuality {
+            get {
+                return this.HasBestKnownQualityField;
+            }
+            set {
+                if ((this.HasBestKnownQualityField.Equals(value) != true)) {
+                    this.HasBestKnownQualityField = value;
+                    this.RaisePropertyChanged("HasBestKnownQuality");
                 }
             }
@@ -136,4 +168,7 @@
         
         [System.Runtime.Serialization.OptionalFieldAttribute()]
+        private bool AssignmentUndefinedField;
+        
+        [System.Runtime.Serialization.OptionalFieldAttribute()]
         private double QualityField;
         
@@ -157,4 +192,17 @@
                     this.AssignmentField = value;
                     this.RaisePropertyChanged("Assignment");
+                }
+            }
+        }
+        
+        [System.Runtime.Serialization.DataMemberAttribute()]
+        public bool AssignmentUndefined {
+            get {
+                return this.AssignmentUndefinedField;
+            }
+            set {
+                if ((this.AssignmentUndefinedField.Equals(value) != true)) {
+                    this.AssignmentUndefinedField = value;
+                    this.RaisePropertyChanged("AssignmentUndefined");
                 }
             }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/Service References/QAPServiceReference/Reference.svcmap
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/Service References/QAPServiceReference/Reference.svcmap	(revision 6732)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/Service References/QAPServiceReference/Reference.svcmap	(revision 6733)
@@ -19,13 +19,13 @@
   </ClientOptions>
   <MetadataSources>
-    <MetadataSource Address="http://localhost:3978/QAP/QAP.svc" Protocol="http" SourceId="1" />
+    <MetadataSource Address="http://services.heuristiclab.com/ProblemInstances-3.3/QAP/QAP.svc" Protocol="http" SourceId="1" />
   </MetadataSources>
   <Metadata>
-    <MetadataFile FileName="QAP.disco" MetadataType="Disco" ID="dea2bc2c-960b-40b9-94ce-8cffa4b02221" SourceId="1" SourceUrl="http://localhost:3978/QAP/QAP.svc?disco" />
-    <MetadataFile FileName="QAP.wsdl" MetadataType="Wsdl" ID="ee1aab36-1ae6-4864-99de-d577d1f3de16" SourceId="1" SourceUrl="http://localhost:3978/QAP/QAP.svc?wsdl" />
-    <MetadataFile FileName="QAP.xsd" MetadataType="Schema" ID="bf8e27bf-7807-41e0-8fe5-0941e9c0b93a" SourceId="1" SourceUrl="http://localhost:3978/QAP/QAP.svc?xsd=xsd2" />
-    <MetadataFile FileName="QAP1.xsd" MetadataType="Schema" ID="4dc00ff5-082c-49a3-b956-0af89ccfc448" SourceId="1" SourceUrl="http://localhost:3978/QAP/QAP.svc?xsd=xsd3" />
-    <MetadataFile FileName="QAP2.xsd" MetadataType="Schema" ID="d883e2c7-abf6-4c20-8d60-23f417b40561" SourceId="1" SourceUrl="http://localhost:3978/QAP/QAP.svc?xsd=xsd0" />
-    <MetadataFile FileName="QAP3.xsd" MetadataType="Schema" ID="c86fad99-c0cb-4ce6-9318-38797ba97040" SourceId="1" SourceUrl="http://localhost:3978/QAP/QAP.svc?xsd=xsd1" />
+    <MetadataFile FileName="QAP1.disco" MetadataType="Disco" ID="b15b4f39-21ff-4118-8aff-d2a421e1d163" SourceId="1" SourceUrl="http://services.heuristiclab.com/ProblemInstances-3.3/QAP/QAP.svc?disco" />
+    <MetadataFile FileName="QAP1.wsdl" MetadataType="Wsdl" ID="d88dc4ea-2680-476d-8346-80a59c48b187" SourceId="1" SourceUrl="http://services.heuristiclab.com/ProblemInstances-3.3/QAP/QAP.svc?wsdl" />
+    <MetadataFile FileName="QAP4.xsd" MetadataType="Schema" ID="6aad67b2-97c7-4a32-9cfd-8475ebf3060c" SourceId="1" SourceUrl="http://services.heuristiclab.com/ProblemInstances-3.3/QAP/QAP.svc?xsd=xsd3" />
+    <MetadataFile FileName="QAP41.xsd" MetadataType="Schema" ID="457c09d3-5cf2-410c-beab-4c8187c62d98" SourceId="1" SourceUrl="http://services.heuristiclab.com/ProblemInstances-3.3/QAP/QAP.svc?xsd=xsd0" />
+    <MetadataFile FileName="QAP42.xsd" MetadataType="Schema" ID="51f1963a-e89f-4e57-8253-252e9d21feca" SourceId="1" SourceUrl="http://services.heuristiclab.com/ProblemInstances-3.3/QAP/QAP.svc?xsd=xsd2" />
+    <MetadataFile FileName="QAP43.xsd" MetadataType="Schema" ID="6adc07a9-4704-4ad0-b2cd-f304b65ee30d" SourceId="1" SourceUrl="http://services.heuristiclab.com/ProblemInstances-3.3/QAP/QAP.svc?xsd=xsd1" />
   </Metadata>
   <Extensions>
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/Service References/QAPServiceReference/configuration.svcinfo
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/Service References/QAPServiceReference/configuration.svcinfo	(revision 6732)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/Service References/QAPServiceReference/configuration.svcinfo	(revision 6733)
@@ -6,5 +6,5 @@
   </bindings>
   <endpoints>
-    <endpoint normalizedDigest="&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-16&quot;?&gt;&lt;Data address=&quot;http://localhost:3978/QAP/QAP.svc&quot; binding=&quot;basicHttpBinding&quot; bindingConfiguration=&quot;BasicHttpBinding_IQAP&quot; contract=&quot;QAPServiceReference.IQAP&quot; name=&quot;BasicHttpBinding_IQAP&quot; /&gt;" digest="&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-16&quot;?&gt;&lt;Data address=&quot;http://localhost:3978/QAP/QAP.svc&quot; binding=&quot;basicHttpBinding&quot; bindingConfiguration=&quot;BasicHttpBinding_IQAP&quot; contract=&quot;QAPServiceReference.IQAP&quot; name=&quot;BasicHttpBinding_IQAP&quot; /&gt;" contractName="QAPServiceReference.IQAP" name="BasicHttpBinding_IQAP" />
+    <endpoint normalizedDigest="&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-16&quot;?&gt;&lt;Data address=&quot;http://services.heuristiclab.com/ProblemInstances-3.3/QAP/QAP.svc&quot; binding=&quot;basicHttpBinding&quot; bindingConfiguration=&quot;BasicHttpBinding_IQAP&quot; contract=&quot;QAPServiceReference.IQAP&quot; name=&quot;BasicHttpBinding_IQAP&quot; /&gt;" digest="&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-16&quot;?&gt;&lt;Data address=&quot;http://services.heuristiclab.com/ProblemInstances-3.3/QAP/QAP.svc&quot; binding=&quot;basicHttpBinding&quot; bindingConfiguration=&quot;BasicHttpBinding_IQAP&quot; contract=&quot;QAPServiceReference.IQAP&quot; name=&quot;BasicHttpBinding_IQAP&quot; /&gt;" contractName="QAPServiceReference.IQAP" name="BasicHttpBinding_IQAP" />
   </endpoints>
 </configurationSnapshot>
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/Service References/QAPServiceReference/configuration91.svcinfo
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/Service References/QAPServiceReference/configuration91.svcinfo	(revision 6732)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/Service References/QAPServiceReference/configuration91.svcinfo	(revision 6733)
@@ -1,4 +1,4 @@
 <?xml version="1.0" encoding="utf-8"?>
-<SavedWcfConfigurationInformation xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" Version="9.1" CheckSum="PGSA1ejV32Fh0z8GmGBf7NFeB0w=">
+<SavedWcfConfigurationInformation xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" Version="9.1" CheckSum="Ik4GzQEYPImjtoibudTmBx1Uums=">
   <bindingConfigurations>
     <bindingConfiguration bindingType="basicHttpBinding" name="BasicHttpBinding_IQAP">
@@ -113,8 +113,8 @@
   </bindingConfigurations>
   <endpoints>
-    <endpoint name="BasicHttpBinding_IQAP" contract="QAPServiceReference.IQAP" bindingType="basicHttpBinding" address="http://localhost:3978/QAP/QAP.svc" bindingConfiguration="BasicHttpBinding_IQAP">
+    <endpoint name="BasicHttpBinding_IQAP" contract="QAPServiceReference.IQAP" bindingType="basicHttpBinding" address="http://services.heuristiclab.com/ProblemInstances-3.3/QAP/QAP.svc" bindingConfiguration="BasicHttpBinding_IQAP">
       <properties>
         <property path="/address" isComplexType="false" isExplicitlyDefined="true" clrType="System.Uri, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
-          <serializedValue>http://localhost:3978/QAP/QAP.svc</serializedValue>
+          <serializedValue>http://services.heuristiclab.com/ProblemInstances-3.3/QAP/QAP.svc</serializedValue>
         </property>
         <property path="/behaviorConfiguration" isComplexType="false" isExplicitlyDefined="false" clrType="System.String, mscorlib, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.QuadraticAssignment/3.3/HeuristicLab.Problems.QuadraticAssignment-3.3.csproj
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.QuadraticAssignment/3.3/HeuristicLab.Problems.QuadraticAssignment-3.3.csproj	(revision 6732)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.QuadraticAssignment/3.3/HeuristicLab.Problems.QuadraticAssignment-3.3.csproj	(revision 6733)
@@ -233,6 +233,4 @@
     <EmbeddedResource Include="Data\tai100a.dat" />
     <EmbeddedResource Include="Data\tai100b.dat" />
-    <EmbeddedResource Include="Data\tai10a.dat" />
-    <EmbeddedResource Include="Data\tai10b.dat" />
     <EmbeddedResource Include="Data\tai12a.dat" />
     <EmbeddedResource Include="Data\tai12b.dat" />
Index: /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances.QAPInitializer/Program.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances.QAPInitializer/Program.cs	(revision 6732)
+++ /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances.QAPInitializer/Program.cs	(revision 6733)
@@ -1,3 +1,4 @@
 ﻿using System;
+using System.Linq;
 using System.Text;
 using HeuristicLab.Problems.QuadraticAssignment;
@@ -10,27 +11,35 @@
         foreach (string instance in qap.EmbeddedInstances) {
           qap.LoadEmbeddedInstance(instance);
-          // transform matrices into jagged arrays
-          double[][] weights = new double[qap.Weights.Rows][];
-          double[][] distances = new double[qap.Weights.Rows][];
-          for (int i = 0; i < weights.Length; i++) {
-            weights[i] = new double[weights.Length];
-            distances[i] = new double[weights.Length];
-            for (int j = 0; j < weights.Length; j++) {
-              weights[i][j] = qap.Weights[i, j];
-              distances[i][j] = qap.Distances[i, j];
+          // transform DoubleMatrix into multidimensional array
+          double[,] weights = new double[qap.Weights.Rows, qap.Weights.Columns];
+          double[,] distances = new double[qap.Distances.Rows, qap.Distances.Columns];
+          for (int i = 0; i < weights.GetLength(0); i++) {
+            for (int j = 0; j < weights.GetLength(1); j++) {
+              weights[i, j] = qap.Weights[i, j];
+              distances[i, j] = qap.Distances[i, j];
             }
           }
 
           QAPInstance dbInstance = context.CreateObject<QAPInstance>();
-          dbInstance.name = qap.Name;
-          dbInstance.description = qap.Description;
-          dbInstance.maximization = qap.Maximization.Value;
-          dbInstance.weights = PrimitiveSerializer.SerializeDoubleMatrix(weights);
-          dbInstance.weights_sha1 = GetSHA1Hash(dbInstance.weights);
-          dbInstance.distances = PrimitiveSerializer.SerializeDoubleMatrix(distances);
-          dbInstance.distances_sha1 = GetSHA1Hash(dbInstance.distances);
-          dbInstance.problemsize = qap.Weights.Rows;
+          dbInstance.Name = qap.Name;
+          dbInstance.Description = qap.Description;
+          dbInstance.Maximization = qap.Maximization.Value;
+          dbInstance.Weights = SimpleSerializer.SerializeDoubleMatrix(weights);
+          dbInstance.WeightsHash = GetSHA1Hash(dbInstance.Weights);
+          dbInstance.Distances = SimpleSerializer.SerializeDoubleMatrix(distances);
+          dbInstance.DistancesHash = GetSHA1Hash(dbInstance.Distances);
+          dbInstance.ProblemSize = qap.Weights.Rows;
+          context.QAPInstances.AddObject(dbInstance);
 
-          context.QAPInstances.AddObject(dbInstance);
+          if (qap.BestKnownQuality != null) {
+            QAPSolution dbSolution = context.CreateObject<QAPSolution>();
+            if (qap.BestKnownSolution != null) {
+              dbSolution.Assignment = SimpleSerializer.SerializeIntArray(qap.BestKnownSolution.ToArray());
+              dbSolution.AssignmentHash = GetSHA1Hash(dbSolution.Assignment);
+            }
+            dbSolution.Instance = dbInstance;
+            dbSolution.Quality = qap.BestKnownQuality.Value;
+            context.QAPSolutions.AddObject(dbSolution);
+          }
         }
         context.SaveChanges();
Index: /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/Auxiliary.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/Auxiliary.cs	(revision 6733)
+++ /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/Auxiliary.cs	(revision 6733)
@@ -0,0 +1,46 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Text;
+
+namespace HeuristicLab.Services.ProblemInstances {
+  public class Auxiliary {
+    public static string GetSHA1Hash(string text) {
+      var SHA1 = new System.Security.Cryptography.SHA1CryptoServiceProvider();
+
+      byte[] arrayData;
+      byte[] arrayResult;
+      string result = null;
+      string temp = null;
+
+      arrayData = Encoding.ASCII.GetBytes(text);
+      arrayResult = SHA1.ComputeHash(arrayData);
+      for (int i = 0; i < arrayResult.Length; i++) {
+        temp = Convert.ToString(arrayResult[i], 16);
+        if (temp.Length == 1)
+          temp = "0" + temp;
+        result += temp;
+      }
+      return result;
+    }
+  }
+}
Index: /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/HeuristicLab.Services.ProblemInstances-3.3.csproj
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/HeuristicLab.Services.ProblemInstances-3.3.csproj	(revision 6732)
+++ /branches/GeneralizedQAP/HeuristicLab.Services.ProblemInstances/HeuristicLab.Services.ProblemInstances-3.3.csproj	(revision 6733)
@@ -23,4 +23,16 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+    <PublishDatabaseSettings>
+      <Objects>
+        <ObjectGroup Name="ProblemInstancesEntities-Deployment" Order="1">
+          <Destination Path="" />
+          <Object Type="dbFullSql">
+            <PreSource Path="Data Source=LOCALHOST\SQLEXPRESS%3bInitial Catalog=HeuristicLab.ProblemInstances%3bIntegrated Security=True%3bPooling=False" ScriptSchema="True" ScriptData="False" CopyAllFullTextCatalogs="False" />
+            <Source Path="obj\Debug\AutoScripts\ProblemInstancesEntities-Deployment_SchemaOnly.sql" Transacted="True" />
+          </Object>
+        </ObjectGroup>
+      </Objects>
+    </PublishDatabaseSettings>
+    <ExcludeGeneratedDebugSymbol>false</ExcludeGeneratedDebugSymbol>
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
@@ -31,4 +43,15 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+    <PublishDatabaseSettings>
+      <Objects>
+      </Objects>
+    </PublishDatabaseSettings>
+    <ExcludeGeneratedDebugSymbol>true</ExcludeGeneratedDebugSymbol>
+  </PropertyGroup>
+  <PropertyGroup>
+    <SignAssembly>true</SignAssembly>
+  </PropertyGroup>
+  <PropertyGroup>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
   </PropertyGroup>
   <ItemGroup>
@@ -55,6 +78,9 @@
   </ItemGroup>
   <ItemGroup>
+    <None Include="QAP\Initial.sql" />
     <Content Include="QAP\QAP.svc" />
-    <Content Include="Web.config" />
+    <Content Include="Web.config">
+      <SubType>Designer</SubType>
+    </Content>
     <Content Include="Web.Debug.config">
       <DependentUpon>Web.config</DependentUpon>
@@ -69,7 +95,9 @@
       <LastGenOutput>ProblemInstancesModel.Designer.cs</LastGenOutput>
     </EntityDeploy>
+    <None Include="HeuristicLab.snk" />
     <None Include="Properties\AssemblyInfo.frame" />
-    <Compile Include="PrimitiveSerializationException.cs" />
-    <Compile Include="PrimitiveSerializer.cs" />
+    <Compile Include="Auxiliary.cs" />
+    <Compile Include="SimpleSerializationException.cs" />
+    <Compile Include="SimpleSerializer.cs" />
     <Compile Include="ProblemInstancesModel.Designer.cs">
       <AutoGen>True</AutoGen>
